#ifndef XPATHNODEDYNAMIC_H
#define XPATHNODEDYNAMIC_H

#include "xasset.h"
#include "xsentienthandle.h"

#include <QVector>

class XPathNodeDynamic : public XAsset
{
public:
    explicit XPathNodeDynamic();
    ~XPathNodeDynamic();

    void ParseData(QDataStream *aStream) override;
    void Clear() override;

    XSentientHandle* GetOwner() const;
    void SetOwner(XSentientHandle *owner);

    int GetFreeTime() const;
    void SetFreeTime(int time);

    QVector<int> GetValidTime() const;
    void SetValidTime(QVector<int> aValidTime);

    int GetPlayerLostTime() const;
    void SetPlayerLostTime(int time);

    short GetLinkCount() const;
    void SetLinkCount(short count);

    short GetOverlapCount() const;
    void SetOverlapCount(short count);

    short GetTurretEntNumber() const;
    void SetTurretEntNumber(short number);

    short GetUserCount() const;
    void SetUserCount(short count);

private:
    XSentientHandle* mOwner;
    int mFreeTime;
    QVector<int> mValidTime;
    int mPlayerLostTime;
    short mLinkCount;
    short mOverlapCount;
    short mTurretEntNumber;
    short mUserCount;
};

#endif // XPATHNODEDYNAMIC_H
